-- Schema: C6MartPeriodico
-- Stored Procedure: PL_D_S157ConfrontoPiramidi

-- =============================================
-- Author:		Paolo Giovanetti
-- Create date: 11/11/2008
-- Description:	<Description,,>
-- =============================================
-- [C6MartPeriodico].[PL_DT_S157ConfrontoPiramidi] 'F','BNNDRC23B44E689L'
CREATE procedure [C6MartPeriodico].[PL_D_S157ConfrontoPiramidi]
	-- Add the parameters for the stored procedure here
	@Rete char(1), 
	@CodiceFiscale varchar(16)
AS
BEGIN
	
	SELECT 
		PIRAMIDE_MOD.RETE, 
		PIRAMIDE_MOD.COD_FISCALE, 	
		PIRAMIDE_MOD.ID_AREA,
		PIRAMIDE_MOD.PERC_AREA,
		PIRAMIDE_VERT.CTV_AREA AS CONTROVALORE
	INTO #PIRAMIDE_VERT
	FROM 
		C6MartPeriodico.PIRAMIDE_MOD
	LEFT JOIN (
		-- GROUP BY PER ACCORPARE I CTV_AREA SULLE PRE1 E PRE2 IN UNO UNICO CORRISPONDENTE A PRE
	    SELECT 
			RETE, 
			COD_FISCALE, 
			LEFT(ID_AREA,3) AS ID_AREA, 
			SUM(COALESCE(CTV,0)) AS CTV_AREA
		FROM
			C6MARTPERIODICO.PATRIMONIO_BF  PIRAMIDE_VERT
		WHERE 
			PIRAMIDE_VERT.RETE = @Rete
			AND PIRAMIDE_VERT.COD_FISCALE = @CodiceFiscale
            --modificata atringali -- AND   ID_AREA NOT IN ('Cc')
		GROUP BY 
			RETE, COD_FISCALE, LEFT(ID_AREA,3) 
	) PIRAMIDE_VERT 
		ON 
			PIRAMIDE_VERT.ID_AREA = PIRAMIDE_MOD.ID_AREA
	WHERE 
            --modificata atringali --  (PIRAMIDE_MOD.ID_AREA IN ('RIS','EXT','LIQ','PRE','NA')
		(PIRAMIDE_MOD.ID_AREA IN ('RIS','EXT','LIQ','PRE','NA', 'CC')
			OR (PIRAMIDE_MOD.ID_AREA = 'INV' AND PIRAMIDE_MOD.NOME_PROGETTO IS NULL))
		AND PIRAMIDE_MOD.RETE = @Rete
		AND PIRAMIDE_MOD.COD_FISCALE = @CodiceFiscale


	IF(@@ROWCOUNT>0)
	BEGIN

		-- Ordinamento per Area di bisogno
		DECLARE @TOTControvaloreAttuale DECIMAL(20,2)

		SELECT @TOTControvaloreAttuale = SUM(ATTUALE.CONTROVALORE)
		FROM #PIRAMIDE_VERT ATTUALE
		WHERE ATTUALE.RETE = @Rete
			AND ATTUALE.COD_FISCALE = @CodiceFiscale
			--V
			AND ID_AREA not in ('Na', 'Cc')
		--V 
			DECLARE @TOTCC AS INT
			SELECT @TOTCC = COUNT(*)
			FROM C6MARTPERIODICO.PATRIMONIO_BF
			WHERE PATRIMONIO_BF.RETE = @Rete
				AND PATRIMONIO_BF.COD_FISCALE = @CodiceFiscale
				AND TIPO_PRODOTTO = 'Cc'

			--V 
			DECLARE @TOT AS INT
			SELECT @TOT = COUNT(*)
			FROM C6MARTPERIODICO.PATRIMONIO_BF
			WHERE PATRIMONIO_BF.RETE = @Rete
				AND PATRIMONIO_BF.COD_FISCALE = @CodiceFiscale
				
		SELECT 
			AREA_BISOGNO.ID_AREA AS NeedArea,
			AREA_BISOGNO.NOME_AREA AS AreaName,
			ISNULL(ATTUALE.PERC_AREA,0) AS PercentualeModello,
			CASE 
				WHEN @TOTControvaloreAttuale = 0 THEN 0 
				ELSE (100 * ISNULL(ATTUALE.CONTROVALORE,0) / ISNULL(@TOTControvaloreAttuale,1)) 
			END AS PercentualeAttuale,
			ROUND(ISNULL(ATTUALE.CONTROVALORE,0),2) AS ControvaloreAttuale,
			ROUND(ISNULL(ATTUALE.PERC_AREA * @TOTControvaloreAttuale / 100 , 0),2) AS ControvaloreModello,
			ATTUALE.PERC_AREA AS Totale_Percentuale,
			ROUND(ISNULL(ATTUALE.CONTROVALORE,0),2) - ROUND(ISNULL(ATTUALE.PERC_AREA * @TOTControvaloreAttuale / 100 , 0),2) AS DifferenzaEuro,
			CASE 
				WHEN @TOTControvaloreAttuale = 0 THEN - ATTUALE.PERC_AREA 
				ELSE ISNULL( (100 * ISNULL(ATTUALE.CONTROVALORE,0) / @TOTControvaloreAttuale - ATTUALE.PERC_AREA) , 0)
			END AS DifferenzaPercentuale,
			ISNULL(RISCHIOAREA.VAR_PERC_PTF,0) AS var_needarea,
			
			

			CASE
				WHEN RISCHIOAREA.COPERTURA IS NULL THEN 'n.c.' 
				WHEN RISCHIOAREA.COPERTURA = 0 THEN 'n.c.' 
				ELSE NULL 
			END AS var_needareaString,
			ISNULL(RISCHIOAREA.COPERTURA,0) AS copertura_needarea,
			CASE 
				WHEN RISCHIOAREA.COPERTURA IS NULL THEN 'n.c.' 
				WHEN RISCHIOAREA.COPERTURA = 0 THEN '0,00' 
				ELSE NULL 
			END AS copertura_needareaString,
			0 AS Nota, --TODO: VERIFICARE REGOLA PER LA NOTA
			ISNULL(@TOTControvaloreAttuale,0) AS somma_controvalAttuale,
			ISNULL(@TOTControvaloreAttuale,0) AS somma_controvalModello,
			0.00 AS somma_percentualeAttuale,
			0.00 AS somma_percentualeModello,
			--V
				CASE
					WHEN @TOTCC = @TOT THEN 0.00
					ELSE RISCHIOTOTALE.VAR_PERC_PTF 
				END 
